AlgorithmParameterGenerator

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.security
Class AlgorithmParameterGenerator

    java.lang.Object
      java.security.AlgorithmParameterGenerator

    public class AlgorithmParameterGenerator

extends Object

The `AlgorithmParameterGenerator` class is used to generate a set of parameters to be used with a certain algorithm. Parameter generators are constructed using the `getInstance` factory methods (static methods that return instances of a given class).

The object that will generate the parameters can be initialized in two different ways: in an algorithm-independent manner, or in an algorithm-specific manner:

- The algorithm-independent approach uses the fact that all parameter generators share the concept of a "size" and a source of randomness. The measure of size is universally shared by all algorithm parameters, though it is interpreted differently for different algorithms. For example, in the case of parameters for the DSA algorithm, "size" corresponds to the size of the prime modulus (in bits). When using this approach, algorithm-specific parameter generation values - if any - default to some standard values, unless they can be derived from the specified size.

- The other approach initializes a parameter generator object using algorithm-specific semantics, which are represented by a set of algorithm-specific parameter generation values. To generate Diffie-Hellman system parameters, for example, the parameter generation values usually consist of the size of the prime modulus and the size of the random exponent, both specified in number of bits.

In case the client does not explicitly initialize the AlgorithmParameterGenerator (via a call to an `init` method), each provider must supply (and document) a default initialization. For example, the Sun provider uses a default modulus prime size of 1024 bits for the generation of DSA parameters.

Since:
  1.2
Version:
  1.36, 02/02/00
Author:
  Jan Luehe
See Also:
  `AlgorithmParameters`, `AlgorithmParameterSpec`

Method Summary
`AlgorithmParameters` | `generateParameters()` Generates the parameters.
`String` | `getAlgorithm()` Returns the standard name of the algorithm this parameter generator is associated with.
`static AlgorithmParameterGenerator` | `getInstance(String algorithm)` Generates an AlgorithmParameterGenerator object that implements the specified digest algorithm.
`static AlgorithmParameterGenerator` | `getInstance(String algorithm, Provider provider)` Generates an AlgorithmParameterGenerator object for the requested algorithm, as supplied from the specified provider, if such a parameter generator is available from the provider.
`static AlgorithmParameterGenerator` | `getInstance(String algorithm, String provider)` Generates an AlgorithmParameterGenerator object for the requested algorithm, as supplied from the specified provider, if such a parameter generator is available from the provider.
`Provider` | `getProvider()` Returns the provider of this algorithm parameter generator object.
`void` | `init(AlgorithmParameterSpec genParamSpec)` Initializes this parameter generator with a set of algorithm-specific parameter generation values.
`void` | `init(AlgorithmParameterSpec genParamSpec, SecureRandom random)` Initializes this parameter generator with a set of algorithm-specific parameter generation values.
`void` | `init(int size)` Initializes this parameter generator for a certain size.
`void` | `init(int size, SecureRandom random)` Initializes this parameter generator for a certain size and source of randomness.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### getAlgorithm

    public final String getAlgorithm()

  Returns the standard name of the algorithm this parameter generator is associated with.

  Returns:
    the string name of the algorithm.

### getInstance

    public static AlgorithmParameterGenerator getInstance(String algorithm)
                                                   throws NoSuchAlgorithmException

  Generates an AlgorithmParameterGenerator object that implements the specified digest algorithm. If the default provider package provides an implementation of the requested digest algorithm, an instance of AlgorithmParameterGenerator containing that implementation is returned. If the algorithm is not available in the default package, other packages are searched.

  Parameters:
    `algorithm` - the string name of the algorithm this parameter generator is associated with.
  Returns:
    the new AlgorithmParameterGenerator object.
  Throws:
    `NoSuchAlgorithmException` - if the algorithm is not available in the environment.

### getInstance

    public static AlgorithmParameterGenerator getInstance(String algorithm,
                                                          String provider)
                                                   throws NoSuchAlgorithmException,
                                                          NoSuchProviderException

  Generates an AlgorithmParameterGenerator object for the requested algorithm, as supplied from the specified provider, if such a parameter generator is available from the provider.

  Parameters:
    `algorithm` - the string name of the algorithm.
    `provider` - the string name of the provider.
  Returns:
    the new AlgorithmParameterGenerator object.
  Throws:
    `NoSuchAlgorithmException` - if the algorithm is not available from the provider.
    `NoSuchProviderException` - if the provider is not available in the environment.
    `IllegalArgumentException` - if the provider name is null or empty.
  See Also:
    `Provider`

### getInstance

    public static AlgorithmParameterGenerator getInstance(String algorithm,
                                                          Provider provider)
                                                   throws NoSuchAlgorithmException

  Generates an AlgorithmParameterGenerator object for the requested algorithm, as supplied from the specified provider, if such a parameter generator is available from the provider. Note: the `provider` doesn't have to be registered.

  Parameters:
    `algorithm` - the string name of the algorithm.
    `provider` - the provider.
  Returns:
    the new AlgorithmParameterGenerator object.
  Throws:
    `NoSuchAlgorithmException` - if the algorithm is not available from the provider.
    `IllegalArgumentException` - if the `provider` is null.
  Since:
    1.4
  See Also:
    `Provider`

### getProvider

    public final Provider getProvider()

  Returns the provider of this algorithm parameter generator object.

  Returns:
    the provider of this algorithm parameter generator object

### init

    public final void init(int size)

  Initializes this parameter generator for a certain size. To create the parameters, the `SecureRandom` implementation of the highest-priority installed provider is used as the source of randomness. (If none of the installed providers supply an implementation of `SecureRandom`, a system-provided source of randomness is used.)

  Parameters:
    `size` - the size (number of bits).

### init

    public final void init(int size,
                           SecureRandom random)

  Initializes this parameter generator for a certain size and source of randomness.

  Parameters:
    `size` - the size (number of bits).
    `random` - the source of randomness.

### init

    public final void init(AlgorithmParameterSpec genParamSpec)
                    throws InvalidAlgorithmParameterException

  Initializes this parameter generator with a set of algorithm-specific parameter generation values. To generate the parameters, the `SecureRandom` implementation of the highest-priority installed provider is used as the source of randomness. (If none of the installed providers supply an implementation of `SecureRandom`, a system-provided source of randomness is used.)

  Parameters:
    `genParamSpec` - the set of algorithm-specific parameter generation values.
  Throws:
    `InvalidAlgorithmParameterException` - if the given parameter generation values are inappropriate for this parameter generator.

### init

    public final void init(AlgorithmParameterSpec genParamSpec,
                           SecureRandom random)
                    throws InvalidAlgorithmParameterException

  Initializes this parameter generator with a set of algorithm-specific parameter generation values.

  Parameters:
    `genParamSpec` - the set of algorithm-specific parameter generation values.
    `random` - the source of randomness.
  Throws:
    `InvalidAlgorithmParameterException` - if the given parameter generation values are inappropriate for this parameter generator.

### generateParameters

    public final AlgorithmParameters generateParameters()

  Generates the parameters.

  Returns:
    the new AlgorithmParameters object.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD